/**
 * \file
 *
 * \brief HAL(ʰ޳ۑw)
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "dali_hal.h"

void dali_hal_forward_decode_disable(void)
{
	usart_rx_disable(USART_SERIAL);
}

void dali_hal_forward_decode_enable(void)
{
	dali_usart_set_rs232_rx(USART_SERIAL);
}

void dali_hal_disable_fading_interrupt(void)
{
	tc45_set_overflow_interrupt_level(&TCC4, TC45_INT_LVL_OFF);
}

void dali_hal_enable_fading_interrupt(void)
{
	tc45_set_overflow_interrupt_level(&TCC4, TC45_INT_LVL_HI);
}

void dali_hal_clear_fading_interrupt_flag(void)
{
	TCC4.INTFLAGS |= TC4_OVFIF_bm;
}

bool dali_hal_get_dali_input_level(void)
{
	return (ioport_get_pin_level(DALI_INPUT));
}

void dali_hal_fading_interrupt_callback(tc45_callback_t callback)
{
	tc45_set_overflow_interrupt_callback(&TCC4, callback);
}

void dali_hal_disable_frame_timer_interrupt(void)
{
	tc45_set_overflow_interrupt_level(&TCD5, TC45_INT_LVL_OFF);
}

void dali_hal_enable_frame_timer_interrupt(void)
{
	tc45_set_overflow_interrupt_level(&TCD5, TC45_INT_LVL_LO);
}

